Index: trunk/FACT++/dim/src/dis.c
===================================================================
--- trunk/FACT++/dim/src/dis.c	(revision 14939)
+++ trunk/FACT++/dim/src/dis.c	(revision 15282)
@@ -201,5 +201,5 @@
 	if(Dis_packet_size)
 		free(Dis_packet);
-	Dis_packet = (DIS_STAMPED_PACKET *)malloc(DIS_STAMPED_HEADER + size);
+	Dis_packet = (DIS_STAMPED_PACKET *)malloc((size_t)(DIS_STAMPED_HEADER + size));
 	if(Dis_packet)
 	{
@@ -213,10 +213,10 @@
 static int check_service_name(char *name)
 {
-	if(strlen(name) > (MAX_NAME - 1))
+	if((int)strlen(name) > (MAX_NAME - 1))
 		return(0);
 	return(1);
 }
 
-static void dis_init()
+void dis_init()
 {
 	int dis_hash_service_init();
@@ -266,8 +266,8 @@
 	}
 	new_serv = (SERVICE *)malloc( sizeof(SERVICE) );
-	strncpy( new_serv->name, name, MAX_NAME );
+	strncpy( new_serv->name, name, (size_t)MAX_NAME );
 	if(type != (char *)0)
 	{
-		if (strlen(type) >= MAX_NAME)
+		if ((int)strlen(type) >= MAX_NAME)
 		{
 			strcpy(str,"Format String Too Long: ");
@@ -441,5 +441,5 @@
 	}
 	new_serv = (SERVICE *)malloc(sizeof(SERVICE));
-	strncpy(new_serv->name, name, MAX_NAME);
+	strncpy(new_serv->name, name, (size_t)MAX_NAME);
 	if(type != (char *)0)
 	{
@@ -783,5 +783,5 @@
   dis_dns_p->n_services = htovl(n_services);
   dis_dns_p->size = htovl(DIS_DNS_HEADER +
-					n_services * sizeof(SERVICE_REG));
+					n_services * (int)sizeof(SERVICE_REG));
   serv_regp = dis_dns_p->services;
   strcpy( serv_regp->service_name, "DUMMY_UPDATE_PACKET" );
@@ -796,5 +796,5 @@
 }
       if( !dna_write(dnsp->dns_dis_conn_id, &(dnsp->dis_dns_packet),
-		     DIS_DNS_HEADER + n_services * sizeof(SERVICE_REG)))
+		     DIS_DNS_HEADER + n_services * (int)sizeof(SERVICE_REG)))
 	  {
 		release_conn(dnsp->dns_dis_conn_id, 0, 1);
@@ -826,5 +826,5 @@
 */
 		strncpy( dis_dns_p->task_name, dnsp->task_name,
-			MAX_TASK_NAME-4 );
+			(size_t)(MAX_TASK_NAME-4) );
 		dis_dns_p->task_name[MAX_TASK_NAME-4-1] = '\0';
 		get_node_addr( dis_dns_p->node_addr );
@@ -852,5 +852,5 @@
 		dis_dns_p->n_services = htovl(n_services);
 		dis_dns_p->size = htovl( DIS_DNS_HEADER + 
-			(n_services*sizeof(SERVICE_REG)));
+			(n_services*(int)sizeof(SERVICE_REG)));
 		if(dnsp->dns_dis_conn_id > 0)
 		{
@@ -863,5 +863,5 @@
 }
 			if(!dna_write(dnsp->dns_dis_conn_id, &(dnsp->dis_dns_packet), 
-				DIS_DNS_HEADER + n_services*sizeof(SERVICE_REG)))
+				DIS_DNS_HEADER + n_services*(int)sizeof(SERVICE_REG)))
 			{
 				release_conn(dnsp->dns_dis_conn_id, 0, 1);
@@ -917,6 +917,6 @@
 		{
 			dis_dns_p->n_services = htovl(n_services);
-			dis_dns_p->size = htovl(DIS_DNS_HEADER +
-				n_services * sizeof(SERVICE_REG));
+			dis_dns_p->size = (int)htovl(DIS_DNS_HEADER +
+				n_services * (int)sizeof(SERVICE_REG));
 			if(dnsp->dns_dis_conn_id > 0)
 			{
@@ -931,5 +931,5 @@
 					   &(dnsp->dis_dns_packet), 
 					   DIS_DNS_HEADER + n_services *
-						sizeof(SERVICE_REG)) )
+						(int)sizeof(SERVICE_REG)) )
 				{
 					release_conn(dnsp->dns_dis_conn_id, 0, 1);
@@ -946,5 +946,5 @@
 		dis_dns_p->n_services = htovl(n_services);
 		dis_dns_p->size = htovl(DIS_DNS_HEADER +
-					n_services * sizeof(SERVICE_REG));
+					n_services * (int)sizeof(SERVICE_REG));
 		if(dnsp->dns_dis_conn_id > 0)
 		{
@@ -957,5 +957,5 @@
 }
 			if( !dna_write(dnsp->dns_dis_conn_id, &(dnsp->dis_dns_packet),
-				DIS_DNS_HEADER + n_services * sizeof(SERVICE_REG)))
+				DIS_DNS_HEADER + n_services * (int)sizeof(SERVICE_REG)))
 			{
 				release_conn(dnsp->dns_dis_conn_id, 0, 1);
@@ -990,5 +990,5 @@
 */
 			strncpy( dis_dns_p->task_name, dnsp->task_name,
-				MAX_TASK_NAME-4 );
+				(size_t)(MAX_TASK_NAME-4) );
 			dis_dns_p->task_name[MAX_TASK_NAME-4-1] = '\0';
 			get_node_addr( dis_dns_p->node_addr );
@@ -1001,5 +1001,5 @@
 		strcpy( serv_regp->service_name, servp->name );
 		strcpy( serv_regp->service_def, servp->def );
-		serv_regp->service_id = htovl( servp->id | 0x80000000);
+		serv_regp->service_id = (int)htovl( (unsigned)servp->id | 0x80000000);
 		serv_regp++;
 		n_services = 1;
@@ -1007,5 +1007,5 @@
 		dis_dns_p->n_services = htovl(n_services);
 		dis_dns_p->size = htovl(DIS_DNS_HEADER +
-				n_services * sizeof(SERVICE_REG));
+				n_services * (int)sizeof(SERVICE_REG));
 
 if(Debug_on)
@@ -1017,5 +1017,5 @@
 }
 		if( !dna_write(dnsp->dns_dis_conn_id, &(dnsp->dis_dns_packet), 
-			DIS_DNS_HEADER + n_services * sizeof(SERVICE_REG)) )
+			DIS_DNS_HEADER + n_services * (int)sizeof(SERVICE_REG)) )
 		{
 			release_conn(dnsp->dns_dis_conn_id, 0, 1);
@@ -1098,5 +1098,5 @@
 	extern DIS_DNS_CONN *dis_find_dns(dim_long);
 	DIS_DNS_CONN *dnsp;
-	int more_ids[10] = {0};
+	unsigned int more_ids[10] = {0};
 
 	dis_init();
@@ -1132,5 +1132,5 @@
 	if(Dis_first_time)
 	{
-		strncpy( task_name_aux, task, MAX_TASK_NAME );
+		strncpy( task_name_aux, task, (size_t)MAX_TASK_NAME );
 		task_name_aux[MAX_TASK_NAME-1] = '\0';
 		Port_number = SEEK_PORT;
@@ -1159,5 +1159,5 @@
 
 		more_ids[0] = do_dis_add_service_dns( str0, "L", &Version_number,
-				 sizeof(Version_number), 0, 0, dnsid );
+						sizeof(Version_number), 0, 0, dnsid );
 
 		more_ids[1] = do_dis_add_service_dns( str1, "C", 0, 0, client_info, (dim_long)dnsp, dnsid );
@@ -1464,5 +1464,5 @@
 		if( Dis_packet_size )
 			free( Dis_packet );
-		Dis_packet = (DIS_STAMPED_PACKET *)malloc(DIS_STAMPED_HEADER + size);
+		Dis_packet = (DIS_STAMPED_PACKET *)malloc((size_t)(DIS_STAMPED_HEADER + size));
 		if(!Dis_packet)
 		{
@@ -1487,7 +1487,7 @@
 			tz = 0;
 		        gettimeofday(&tv, tz);
-			aux = tv.tv_usec / 1000;
+			aux = (int)tv.tv_usec / 1000;
 			Dis_packet->time_stamp[0] = htovl(aux);
-			Dis_packet->time_stamp[1] = htovl(tv.tv_sec);
+			Dis_packet->time_stamp[1] = htovl((int)tv.tv_sec);
 #endif
 		}
@@ -1498,5 +1498,5 @@
 			Dis_packet->time_stamp[1] = htovl(servp->user_secs);
 		}
-		Dis_packet->reserved[0] = htovl(0xc0dec0de);
+		Dis_packet->reserved[0] = (int)htovl(0xc0dec0de);
 		Dis_packet->quality = htovl(servp->quality);
 	}
@@ -1566,8 +1566,8 @@
 		return;
 	if( !packet_size ) {
-		dis_packet = (DIS_PACKET *)malloc(DIS_HEADER);
+		dis_packet = (DIS_PACKET *)malloc((size_t)DIS_HEADER);
 		packet_size = DIS_HEADER;
 	}
-	service_id = (reqp->service_id | 0x80000000);
+	service_id = (int)((unsigned)reqp->service_id | 0x80000000);
 	dis_packet->service_id = htovl(service_id);
 	dis_packet->size = htovl(DIS_HEADER);
@@ -1599,5 +1599,5 @@
 	if(!buffer_size)
 	{
-		buffer = (int *)malloc(add_size);
+		buffer = (int *)malloc((size_t)add_size);
 		buffer_size = add_size;
 	} 
@@ -1607,5 +1607,5 @@
 		{
 			free(buffer);
-			buffer = (int *)malloc(add_size);
+			buffer = (int *)malloc((size_t)add_size);
 			buffer_size = add_size;
 		}
@@ -1622,6 +1622,6 @@
 			{
 				if(formatp->flags & IT_IS_FLOAT)
-					formatp->flags |= (format & 0xf0);
-				formatp->flags &= 0xFFF0;	/* NOSWAP */
+					formatp->flags |= ((short)format & (short)0xf0);
+				formatp->flags &= (short)0xFFF0;	/* NOSWAP */
 			}
 		}
@@ -1631,5 +1631,5 @@
 			{
 				if(formatp->flags & IT_IS_FLOAT)
-					formatp->flags |= (format & 0xf0);
+					formatp->flags |= ((short)format & (short)0xf0);
 			}
 		}
@@ -1992,6 +1992,6 @@
 			tz = 0;
 		    gettimeofday(&tv, tz);
-			servp->user_secs = tv.tv_sec;
-			servp->user_millisecs = tv.tv_usec / 1000;
+			servp->user_secs = (int)tv.tv_sec;
+			servp->user_millisecs = (int)tv.tv_usec / 1000;
 #endif
 	}
@@ -2074,5 +2074,5 @@
 	if(!packet_size)
 	{
-		dis_packet = (DIS_PACKET *)malloc(DIS_HEADER+size);
+		dis_packet = (DIS_PACKET *)malloc((size_t)(DIS_HEADER+size));
 		packet_size = DIS_HEADER + size;
 	} 
@@ -2082,5 +2082,5 @@
 		{
 			free(dis_packet);
-			dis_packet = (DIS_PACKET *)malloc(DIS_HEADER+size);
+			dis_packet = (DIS_PACKET *)malloc((size_t)(DIS_HEADER+size));
 			packet_size = DIS_HEADER+size;
 		}
@@ -2091,5 +2091,5 @@
 	{
 		dis_packet->service_id = htovl(reqp->service_id);
-		memcpy(dis_packet->buffer, buffer, size);
+		memcpy(dis_packet->buffer, buffer, (size_t)size);
 		dis_packet->size = htovl(DIS_HEADER + size);
 
@@ -2263,5 +2263,5 @@
 		{
 			ENABLE_AST
-			dis_remove_service(servp->id);
+			dis_remove_service((unsigned)servp->id);
 			{
 			DISABLE_AST
@@ -2371,5 +2371,5 @@
 	{
 		ENABLE_AST
-		dis_remove_service(servp->id);
+		dis_remove_service((unsigned)servp->id);
 		{
 		DISABLE_AST
@@ -2467,5 +2467,5 @@
     int found = 0;
 	int release_request();
-	DIS_DNS_CONN *dnsp;
+	DIS_DNS_CONN *dnsp = 0;
 
 	DISABLE_AST;
@@ -2568,5 +2568,5 @@
 		if(!curr_allocated_size)
 		{
-			service_info_buffer = (char *)malloc(max_size);
+			service_info_buffer = (char *)malloc((size_t)max_size);
 			curr_allocated_size = max_size;
 		}
@@ -2574,5 +2574,5 @@
 		{
 			free(service_info_buffer);
-			service_info_buffer = (char *)malloc(max_size);
+			service_info_buffer = (char *)malloc((size_t)max_size);
 			curr_allocated_size = max_size;
 		}
@@ -2587,5 +2587,5 @@
 			strcat(buff_ptr, servp->name);
 			strcat(buff_ptr, "\n");
-			buff_ptr += strlen(buff_ptr);
+			buff_ptr += (int)strlen(buff_ptr);
 		}
 	}
@@ -2743,9 +2743,9 @@
 		sll_init((SLL *) Cmnds_head);
 	}
-	new_cmnd = (DIS_CMND *)malloc((*size)+12);
+	new_cmnd = (DIS_CMND *)malloc((size_t)((*size)+12));
 	new_cmnd->next = 0;
 	new_cmnd->tag = *tag;
 	new_cmnd->size = *size;
-	memcpy(new_cmnd->buffer, cmnd_buff, *size);
+	memcpy(new_cmnd->buffer, cmnd_buff, (size_t)*size);
 	sll_insert_queue((SLL *) Cmnds_head, (SLL *) new_cmnd);
 }
@@ -2782,5 +2782,5 @@
 			ret_val = 1;
 		}
-		memcpy(buffer, cmndp->buffer, *size);
+		memcpy(buffer, cmndp->buffer, (size_t)*size);
 		*tag = cmndp->tag;
 		free(cmndp);
@@ -2824,5 +2824,5 @@
 
 	strcpy(for_str->dsc$a_pointer, c_str);
-	for(i = strlen(c_str); i< for_str->dsc$w_length; i++)
+	for(i = (int)strlen(c_str); i< for_str->dsc$w_length; i++)
 		for_str->dsc$a_pointer[i] = ' ';
 }
@@ -2843,5 +2843,5 @@
 	if(!curr_allocated_size)
 	{
-		dns_info_buffer = malloc(max_size);
+		dns_info_buffer = malloc((size_t)max_size);
 		curr_allocated_size = max_size;
 	}
@@ -2859,9 +2859,9 @@
 			curr_conns[index++] = clip->conn_id;
 		}
-		max_size = (index+1)*sizeof(DNS_CLIENT_INFO);
+		max_size = (index+1)*(int)sizeof(DNS_CLIENT_INFO);
 		if (max_size > curr_allocated_size)
 		{
 			free(dns_info_buffer);
-			dns_info_buffer = malloc(max_size);
+			dns_info_buffer = malloc((size_t)max_size);
 			curr_allocated_size = max_size;
 		}
@@ -2892,7 +2892,7 @@
 	}
 	if(index)
-		dns_client_info[strlen(dns_client_info)-1] = '\0';
+		dns_client_info[(int)strlen(dns_client_info)-1] = '\0';
 	*bufp = (int *)dns_info_buffer;
-	*size = strlen(dns_info_buffer)+1;
+	*size = (int)strlen(dns_info_buffer)+1;
 }
 
@@ -2967,5 +2967,5 @@
 	if(!curr_allocated_size)
 	{
-		service_info_buffer = (char *)malloc(max_size);
+		service_info_buffer = (char *)malloc((size_t)max_size);
 		curr_allocated_size = max_size;
 	}
@@ -2973,5 +2973,5 @@
 	{
 		free(service_info_buffer);
-		service_info_buffer = (char *)malloc(max_size);
+		service_info_buffer = (char *)malloc((size_t)max_size);
 		curr_allocated_size = max_size;
 	}
@@ -2996,5 +2996,5 @@
 				servp->registered = Last_n_clients+1;
 				append_service(buff_ptr, servp);
-				buff_ptr += strlen(buff_ptr);
+				buff_ptr += (int)strlen(buff_ptr);
 			}
 		}
@@ -3012,7 +3012,7 @@
 			{
 				strcat(buff_ptr, "-");
-				buff_ptr += strlen(buff_ptr);
+				buff_ptr += (int)strlen(buff_ptr);
 				append_service(buff_ptr, servp);
-				buff_ptr += strlen(buff_ptr);
+				buff_ptr += (int)strlen(buff_ptr);
 			}
 			else if(servp->registered < (Last_n_clients+1))
@@ -3021,9 +3021,9 @@
 				{
 					strcat(buff_ptr, "+");
-					buff_ptr += strlen(buff_ptr);
+					buff_ptr += (int)strlen(buff_ptr);
 					done = 1;
 				}
 				append_service(buff_ptr, servp);
-				buff_ptr += strlen(buff_ptr);
+				buff_ptr += (int)strlen(buff_ptr);
 /*
 				servp->registered = 2;
@@ -3034,5 +3034,5 @@
 	}
 	*bufp = (int *)service_info_buffer;
-	*size = buff_ptr - service_info_buffer+1;
+	*size = (int)(buff_ptr - service_info_buffer+1);
 	if(*size == 1)
 		*size = -1;
@@ -3235,4 +3235,5 @@
 int dis_hash_service_init()
 {
+
   int i;
   static int done = 0;
@@ -3242,10 +3243,14 @@
 	for( i = 0; i < MAX_HASH_ENTRIES; i++ ) 
 	{
+/*
 		Service_hash_table[i] = (SERVICE *) malloc(sizeof(SERVICE));
 		dll_init((DLL *) Service_hash_table[i]);
+*/
+		Service_hash_table[i] = 0;
 		Service_new_entries[i] = 0;
 	}
 	done = 1;
   }
+
   return(1);
 }
@@ -3255,4 +3260,9 @@
 	int index;
 	index = HashFunction(servp->name, MAX_HASH_ENTRIES);
+	if(!Service_hash_table[index])
+	{
+		Service_hash_table[index] = (SERVICE *) malloc(sizeof(SERVICE));
+		dll_init((DLL *) Service_hash_table[index]);
+	}
 	Service_new_entries[index]++;
 	dll_insert_queue((DLL *) Service_hash_table[index], 
@@ -3272,4 +3282,10 @@
 int dis_hash_service_remove(SERVICE *servp)
 {
+	int index;
+	index = HashFunction(servp->name, MAX_HASH_ENTRIES);
+	if(!Service_hash_table[index])
+	{
+		return(0);
+	}
 	dll_remove( (DLL *) servp );
 	return(1);
@@ -3283,7 +3299,11 @@
 
 	index = HashFunction(name, MAX_HASH_ENTRIES);
+	if(!Service_hash_table[index])
+	{
+		return((SERVICE *)0);
+	}
 	if( (servp = (SERVICE *) dll_search(
 					(DLL *) Service_hash_table[index],
-			      		name, strlen(name)+1)) )
+			      		name, (int)strlen(name)+1)) )
 	{
 		return(servp);
@@ -3314,11 +3334,14 @@
 	do
 	{
-		if((!new_entries) || (Service_new_entries[index] > 0))
-		{
-			servp = (SERVICE *) dll_get_next(
+		if(prevp)
+		{
+			if((!new_entries) || (Service_new_entries[index] > 0))
+			{
+				servp = (SERVICE *) dll_get_next(
 						(DLL *) Service_hash_table[index],
 						(DLL *) prevp);
-			if(servp)
-				break;
+				if(servp)
+					break;
+			}
 		}
 		index++;
Index: trunk/FACT++/dim/src/discpp.cxx
===================================================================
--- trunk/FACT++/dim/src/discpp.cxx	(revision 14939)
+++ trunk/FACT++/dim/src/discpp.cxx	(revision 15282)
@@ -17,4 +17,6 @@
 
 extern "C" {
+extern void dis_init();
+
 static void user_routine( void *tagp, void **buf, int *size, int *first_time)
 {
@@ -39,5 +41,5 @@
 	}
 	if( t->itsType == DisSTRING)
-			t->itsSize = strlen((char *)t->itsData)+1;
+			t->itsSize = (int)strlen((char *)t->itsData)+1;
 	*buf = t->itsData;
 	*size = t->itsSize;
@@ -49,5 +51,5 @@
 //	itsTagId = 0;
 	itsDns = dns;
-	itsName = new char[strlen(name)+1];
+	itsName = new char[(int)strlen(name)+1];
 	itsDataSize = 0;
 	strcpy( itsName, name);
@@ -57,16 +59,21 @@
 		itsServiceHandler = 0;
 //	itsTagId = id_get((void *)this, SRC_DIS);
+	dis_init();
 	if(itsDns == 0)
 	{
+		DISABLE_AST
 		itsId = dis_add_service( name, format, NULL, 0, 
 //				user_routine, itsTagId);
 				user_routine, (dim_long)this);
+		ENABLE_AST
 		DimServer::start();
 	}
 	else
 	{
+		DISABLE_AST
 		itsId = dis_add_service_dns( itsDns->getDnsId(), name, format, NULL, 0, 
 //				user_routine, itsTagId);
 				user_routine, (dim_long)this);
+		ENABLE_AST
 //		itsDns->addServiceId(itsId);
 		DimServer::start(itsDns);
@@ -88,5 +95,5 @@
 		itsDataSize = size;
 	}
-	memcpy(itsData, data, size);
+	memcpy(itsData, data, (size_t)size);
 	itsSize = size;
 }
@@ -125,7 +132,7 @@
 //	itsTagId = 0;
 	itsDns = dns;
-	itsName = new char[strlen(name)+1];
+	itsName = new char[(int)strlen(name)+1];
 	strcpy( itsName, name);
-	itsFormat = new char[strlen(format)+1];
+	itsFormat = new char[(int)strlen(format)+1];
 	strcpy( itsFormat, format);
 	currCmnd = 0;
@@ -135,16 +142,21 @@
 		itsCommandHandler = 0;
 //	itsTagId = id_get((void *)this, SRC_DIS);
+	dis_init();
 	if(!itsDns)
 	{
+		DISABLE_AST
 		itsId = dis_add_cmnd( name, format, command_routine,
 //				itsTagId);
 				(dim_long)this);
+		ENABLE_AST
 		DimServer::start();
 	}
 	else
 	{
+		DISABLE_AST
 		itsId = dis_add_cmnd_dns( itsDns->getDnsId(), name, format, command_routine,
 //			itsTagId);
 			(dim_long)this);
+		ENABLE_AST
 //		itsDns->addServiceId(itsId);
 		DimServer::start(itsDns);
@@ -230,10 +242,10 @@
 //	itsTagId = 0;
 	itsDns = dns;
-	itsName = new char[strlen(name)+1];
+	itsName = new char[(int)strlen(name)+1];
 	strcpy( itsName, name);
-	itsNameIn = new char[strlen(name)+1+10];
+	itsNameIn = new char[(int)strlen(name)+1+10];
 	strcpy( itsNameIn, name);
 	strcat(itsNameIn,(char *)"/RpcIn");
-	itsNameOut = new char[strlen(name)+1+10];
+	itsNameOut = new char[(int)strlen(name)+1+10];
 	strcpy( itsNameOut, name);
 	strcat(itsNameOut,(char *)"/RpcOut");
@@ -244,6 +256,8 @@
 	
 //	itsTagId = id_get((void *)this, SRC_DIS);
+	dis_init();
 	if(!itsDns)
 	{
+		DISABLE_AST
 		itsIdIn = dis_add_cmnd( itsNameIn, formatin, 
 //			rpcin_routine, itsTagId);
@@ -252,8 +266,10 @@
 //			rpcout_routine, itsTagId);
 			rpcout_routine, (dim_long)this);
+		ENABLE_AST
 		DimServer::start();
 	}
 	else
 	{
+		DISABLE_AST
 		itsIdIn = dis_add_cmnd_dns( itsDns->getDnsId(), itsNameIn, formatin, 
 //			rpcin_routine, itsTagId);
@@ -262,4 +278,5 @@
 //			rpcout_routine, itsTagId);
 			rpcout_routine, (dim_long)this);
+		ENABLE_AST
 //		itsDns->addServiceId(itsIdIn);
 //		itsDns->addServiceId(itsIdOut);
@@ -282,5 +299,5 @@
 		itsDataOutSize = size;
 	}
-	memcpy(itsDataOut, data, size);
+	memcpy(itsDataOut, data, (size_t)size);
 	itsSizeOut = size;
 }
@@ -314,5 +331,5 @@
 //	if(!itsNode)
 //	{
-		itsNode = new char[strlen(node)+1];
+		itsNode = new char[(int)strlen(node)+1];
 		strcpy(itsNode,node);
 //	}
@@ -335,5 +352,5 @@
 	{
 		tmp = new int[itsServiceIdListSize + DisDnsIdBlock];
-		memcpy(tmp, itsServiceIdList, itsServiceIdListSize*sizeof(int));
+		memcpy(tmp, itsServiceIdList, (size_t)itsServiceIdListSize*sizeof(int));
 		delete itsServiceIdList;
 		itsServiceIdList = tmp;
@@ -378,5 +395,5 @@
 	if(!itsName)
 	{
-		itsName = new char[strlen(name)+1];
+		itsName = new char[(int)strlen(name)+1];
 		strcpy(itsName,name);
 	}
@@ -437,5 +454,5 @@
 	if(!itsName)
 	{
-		itsName = new char[strlen(name)+1];
+		itsName = new char[(int)strlen(name)+1];
 		strcpy(itsName,name);
 	}
@@ -447,4 +464,6 @@
 	dim_long dnsid;
 
+	dis_init();
+	{
 	DISABLE_AST
 	dns->setName(name);
@@ -452,4 +471,5 @@
 	dis_start_serving_dns(dnsid, (char *)name /*, dns->getServiceIdList()*/);
 	ENABLE_AST
+	}
 }
 /*
@@ -491,4 +511,6 @@
 	int isAuto;
 
+	dis_init();
+	{
 	DISABLE_AST
 //	dns->itsNServices++;
@@ -503,4 +525,5 @@
 	}
 	ENABLE_AST
+	}
 }
 
@@ -798,5 +821,5 @@
 {
 	itsData = string;
-	itsSize = strlen(string)+1;
+	itsSize = (int)strlen(string)+1;
 	itsType = DisSTRING;
 	declareIt((char *)name, (char *)"C", 0, 0);
@@ -880,5 +903,5 @@
 {
 	itsData = string;
-	itsSize = strlen(string)+1;
+	itsSize = (int)strlen(string)+1;
 	itsType = DisSTRING;
 	declareIt((char *)name, (char *)"C", 0, dns);
@@ -987,5 +1010,5 @@
 	{
 		itsData = string;
-		itsSize = strlen(string)+1;
+		itsSize = (int)strlen(string)+1;
 		return dis_update_service( itsId );
 	}
@@ -1106,5 +1129,5 @@
 	{
 		itsData = string;
-		itsSize = strlen(string)+1;
+		itsSize = (int)strlen(string)+1;
 		if( cids == 0)
 		{
@@ -1179,5 +1202,5 @@
 void DimService::setData(char *data)
 {
-	storeIt(data, strlen(data)+1);
+	storeIt(data, (int)strlen(data)+1);
 }
 
@@ -1204,5 +1227,5 @@
 	secs = tsecs;
 	millisecs = tmillisecs;
-	memcpy(itsData, data, datasize);
+	memcpy(itsData, data, (size_t)datasize);
 }
 
@@ -1465,5 +1488,5 @@
 void DimRpc::setData(char *data)
 {
-	storeIt(data,strlen(data)+1);
+	storeIt(data,(int)strlen(data)+1);
 }
 
Index: trunk/FACT++/dim/src/dll.c
===================================================================
--- trunk/FACT++/dim/src/dll.c	(revision 14939)
+++ trunk/FACT++/dim/src/dll.c	(revision 15282)
@@ -53,5 +53,5 @@
 	DISABLE_AST
 	while( auxp!= head ) {
-		if( !memcmp(auxp->user_info, data, size) ) {
+		if( !memcmp(auxp->user_info, data, (size_t)size) ) {
 			ENABLE_AST
 			return(auxp);
@@ -117,5 +117,5 @@
 	DISABLE_AST
 	while( auxp!= head ) {
-		if( !memcmp(&(auxp->user_info[offset]), data, size) ) {
+		if( !memcmp(&(auxp->user_info[offset]), data, (size_t)size) ) {
 			retp = auxp;
 		}
Index: trunk/FACT++/dim/src/dna.c
===================================================================
--- trunk/FACT++/dim/src/dna.c	(revision 14939)
+++ trunk/FACT++/dim/src/dna.c	(revision 15282)
@@ -248,5 +248,5 @@
 	{
 		dna_connp->buffer =
-				(int *) realloc(dna_connp->buffer, size);
+				(int *) realloc(dna_connp->buffer, (size_t)size);
 		dna_connp->buffer_size = size;
 	}
@@ -428,5 +428,5 @@
 	header_p->header_size = htovl(READ_HEADER_SIZE);
 	header_p->data_size = htovl(size);
-	header_p->header_magic = htovl(HDR_MAGIC);
+	header_p->header_magic = (int)htovl(HDR_MAGIC);
 	tcpip_code = dna_write_bytes(conn_id, &header_pkt, READ_HEADER_SIZE, 1);
 	if(tcpip_failure(tcpip_code)) 
@@ -462,11 +462,11 @@
 	DISABLE_AST
 
-	pktp = malloc(READ_HEADER_SIZE+size);
+	pktp = malloc((size_t)(READ_HEADER_SIZE+size));
 	headerp = &(pktp->header);
 	headerp->header_size = htovl(READ_HEADER_SIZE);
 	headerp->data_size = htovl(size);
-	headerp->header_magic = htovl(HDR_MAGIC);
-
-	memcpy(pktp->data, (char *)buffer, size);
+	headerp->header_magic = (int)htovl(HDR_MAGIC);
+
+	memcpy(pktp->data, (char *)buffer, (size_t)size);
 
 	newp = malloc(sizeof(WRITE_ITEM));
@@ -505,5 +505,5 @@
 	} else {
 		dna_connp->state = RD_HDR;
-		dna_connp->buffer = (int *)malloc(TCP_RCV_BUF_SIZE);
+		dna_connp->buffer = (int *)malloc((size_t)TCP_RCV_BUF_SIZE);
 /*
 		if(!dna_connp->buffer)
@@ -623,5 +623,6 @@
 	register int i, size;
 	time_t oldest;
-	int oldesti;
+	int oldesti = 0;
+	extern time_t time();
 
 	if(type == 0)
@@ -803,5 +804,5 @@
 	dna_connp->state = RD_HDR;
 	dna_connp->writing = FALSE;
-	dna_connp->buffer = (int *)malloc(TCP_RCV_BUF_SIZE);
+	dna_connp->buffer = (int *)malloc((size_t)TCP_RCV_BUF_SIZE);
 /*
 	if(!dna_connp->buffer)
@@ -815,5 +816,5 @@
 	dna_connp->saw_init = TRUE;	/* we send it! */
 	dna_start_read(conn_id, READ_HEADER_SIZE);
-	local_buffer.code = htovl(OPN_MAGIC);
+	local_buffer.code = (int)htovl(OPN_MAGIC);
 	get_node_name(local_buffer.node);
 	get_proc_name(local_buffer.task);
Index: trunk/FACT++/dim/src/dns.c
===================================================================
--- trunk/FACT++/dim/src/dns.c	(revision 14939)
+++ trunk/FACT++/dim/src/dns.c	(revision 15282)
@@ -198,5 +198,5 @@
 	int rem_only = 0;
 
-	Dns_conns[conn_id].validity = time(NULL);
+	Dns_conns[conn_id].validity = (int)time(NULL);
 	if( !Dns_conns[conn_id].service_head ) 
 	{
@@ -205,5 +205,5 @@
 		{
 			service_id = vtohl(packet->services[0].service_id);
-			if(service_id & 0x80000000)
+			if((unsigned)service_id & 0x80000000)
 				rem_only = 1;
 		}
@@ -233,7 +233,7 @@
 		Dns_conns[conn_id].protocol = vtohl(packet->protocol);
 		strncpy( Dns_conns[conn_id].node_name, packet->node_name,
-			MAX_NODE_NAME ); 
+			(size_t)MAX_NODE_NAME ); 
 		strncpy( Dns_conns[conn_id].task_name, packet->task_name,
-			MAX_TASK_NAME-4 );
+			(size_t)(MAX_TASK_NAME-4) );
 		strcpy(Dns_conns[conn_id].long_task_name, packet->task_name);
 		Dns_conns[conn_id].task_name[MAX_TASK_NAME-4-1] = '\0';
@@ -277,5 +277,5 @@
 				{
 					ptr1 = ptr;
-					ptr1 += strlen(ptr);
+					ptr1 += (int)strlen(ptr);
 				}
 				if(strstr(Dns_conns[conn_id].node_name,ptr))
@@ -339,5 +339,5 @@
 	}
 	n_services = vtohl(packet->n_services);
-	if(strlen(Dns_conns[conn_id].task_name) == MAX_TASK_NAME-4-1)
+	if((int)strlen(Dns_conns[conn_id].task_name) == MAX_TASK_NAME-4-1)
 		name_too_long = 1;
 	for( i = 0; i < n_services; i++ ) 
@@ -452,5 +452,5 @@
 					/*there are interested clients waiting*/
 					strncpy( servp->serv_def,
-						packet->services[i].service_def,MAX_NAME );
+						packet->services[i].service_def,(size_t)MAX_NAME );
 					servp->conn_id = conn_id;
 					servp->state = 1;
@@ -475,5 +475,5 @@
 					/* test if Service is to be removed */
 					service_id = vtohl(packet->services[i].service_id);
-					if(service_id & 0x80000000)
+					if((unsigned)service_id & 0x80000000)
 					{
 						dll_remove((DLL *) servp);
@@ -525,5 +525,5 @@
 				{
 					strncpy(Dns_conns[conn_id].long_task_name, packet->services[i].service_name,
-						MAX_NAME);
+						(size_t)MAX_NAME);
 					ptrt = strstr(Dns_conns[conn_id].long_task_name,"/CLIENT_LIST");
 					*ptrt = '\0';
@@ -532,8 +532,8 @@
 			strncpy( servp->serv_name,
 				packet->services[i].service_name,
-				MAX_NAME );
+				(size_t)MAX_NAME );
 			strncpy( servp->serv_def,
 				packet->services[i].service_def,
-				MAX_NAME );
+				(size_t)MAX_NAME );
 			servp->state = 1;
 			servp->conn_id = conn_id;
@@ -628,5 +628,5 @@
 */
 	}
-	time_diff = time(NULL) - Dns_conns[conn_id].validity;
+	time_diff = (int)time(NULL) - Dns_conns[conn_id].validity;
 	if(time_diff > (int)(WATCHDOG_TMOUT_MAX*1.2))
 	{
@@ -700,5 +700,5 @@
 			{
 				ptr1 = ptr;
-				ptr1 += strlen(ptr);
+				ptr1 += (int)strlen(ptr);
 			}
 			if(strstr(Net_conns[conn_id].node,ptr))
@@ -777,5 +777,5 @@
 		return(0);
 	}
-	if( service_id & 0x80000000 )  /* remove service */
+	if( (unsigned)service_id & 0x80000000 )  /* remove service */
 	{
 		service_id &= 0x7fffffff;
@@ -843,5 +843,5 @@
 		}
 		servp = (DNS_SERVICE *) malloc(sizeof(DNS_SERVICE));
-		strncpy( servp->serv_name, serv_regp->service_name, MAX_NAME );
+		strncpy( servp->serv_name, serv_regp->service_name, (size_t)MAX_NAME );
 		servp->serv_def[0] = '\0';
 		servp->state = 0;
@@ -1254,9 +1254,9 @@
 	if(n_services == -1)
 		n_services = 0;
-	max_size = sizeof(DNS_SERVER_INFO) + 
-				n_services * sizeof(DNS_SERVICE_INFO);
+	max_size = (int)sizeof(DNS_SERVER_INFO) + 
+				n_services * (int)sizeof(DNS_SERVICE_INFO);
 	if(!curr_allocated_size)
 	{
-		dns_info_buffer = (DNS_DID *)malloc(max_size);
+		dns_info_buffer = (DNS_DID *)malloc((size_t)max_size);
 		curr_allocated_size = max_size;
 	}
@@ -1264,11 +1264,11 @@
 	{
 		free(dns_info_buffer);
-		dns_info_buffer = (DNS_DID *)malloc(max_size);
+		dns_info_buffer = (DNS_DID *)malloc((size_t)max_size);
 		curr_allocated_size = max_size;
 	}
 	dns_server_info = &dns_info_buffer->server;
 	dns_service_info = dns_info_buffer->services;
-	strncpy(dns_server_info->task, connp->task_name, MAX_TASK_NAME-4);
-	strncpy(dns_server_info->node, connp->node_name, MAX_NODE_NAME);
+	strncpy(dns_server_info->task, connp->task_name, (size_t)(MAX_TASK_NAME-4));
+	strncpy(dns_server_info->node, connp->node_name, (size_t)MAX_NODE_NAME);
 	dns_server_info->pid = htovl(connp->pid);
 	dns_server_info->n_services = htovl(connp->n_services);
@@ -1277,5 +1277,5 @@
 						    (DLL *) servp)) )
 	{
-		strncpy(dns_service_info->name, servp->serv_name, MAX_NAME); 
+		strncpy(dns_service_info->name, servp->serv_name, (size_t)MAX_NAME); 
 		dns_service_info->status = htovl(1);
 		if(servp->serv_id & 0x10000000)
@@ -1314,19 +1314,19 @@
 		}
 	}
-	max_size = (sizeof(DNS_SERVER_INFO) + MAX_TASK_NAME) * n_server;
-	max_pid_size = sizeof(int) * n_server;
+	max_size = ((int)sizeof(DNS_SERVER_INFO) + MAX_TASK_NAME) * n_server;
+	max_pid_size = (int)sizeof(int) * n_server;
 	if(!curr_allocated_size)
 	{
-		info_buffer = (char *)malloc(max_size);
+		info_buffer = (char *)malloc((size_t)max_size);
 		curr_allocated_size = max_size;
-		pid_buffer = (int *)malloc(max_pid_size);
+		pid_buffer = (int *)malloc((size_t)max_pid_size);
 	}
 	else if (max_size > curr_allocated_size)
 	{
 		free(info_buffer);
-		info_buffer = (char *)malloc(max_size);
+		info_buffer = (char *)malloc((size_t)max_size);
 		curr_allocated_size = max_size;
 		free(pid_buffer);
-		pid_buffer = (int *)malloc(max_pid_size);
+		pid_buffer = (int *)malloc((size_t)max_pid_size);
 	}
 	info_buffer[0] = '\0';
@@ -1342,5 +1342,5 @@
 				connp = &Dns_conns[i];
 /*
-				if(strlen(connp->task_name) == MAX_TASK_NAME-4-1)
+				if((int)strlen(connp->task_name) == MAX_TASK_NAME-4-1)
 				{
 					strcpy(aux,connp->task_name);
@@ -1373,5 +1373,5 @@
 				strcat(server,"|");
 				strcpy(info_buffer_ptr, server);
-				info_buffer_ptr += strlen(server);
+				info_buffer_ptr += (int)strlen(server);
 				pid_buffer[pid_index] = connp->pid;
 				pid_index++;
@@ -1395,6 +1395,6 @@
 		pid_index++;
 	}
-	info_buffer[strlen(info_buffer) - 1] = '\0';
-	info_buffer_ptr = &info_buffer[strlen(info_buffer)+1];
+	info_buffer[(int)strlen(info_buffer) - 1] = '\0';
+	info_buffer_ptr = &info_buffer[(int)strlen(info_buffer)+1];
 	pid_size = 0;
 	for(i = 0; i < pid_index; i++)
@@ -1405,9 +1405,9 @@
 			sprintf(server, "%d",pid_buffer[i]);
 		strcpy(info_buffer_ptr, server);
-		info_buffer_ptr += strlen(server);
-		pid_size += strlen(server);
+		info_buffer_ptr += (int)strlen(server);
+		pid_size += (int)strlen(server);
 	}
 	*bufp = (int *)info_buffer;
-	*size = strlen(info_buffer)+1+pid_size+1;
+	*size = (int)strlen(info_buffer)+1+pid_size+1;
 	ENABLE_AST
 }
@@ -1444,7 +1444,7 @@
 	fflush(stdout);
 
-	Server_new_info_id = dis_add_service( "DIS_DNS/SERVER_LIST", "C", 0, 0, 
+	Server_new_info_id =(int) dis_add_service( "DIS_DNS/SERVER_LIST", "C", 0, 0, 
 						get_new_dns_server_info, 0 );
-	Server_info_id = dis_add_service( "DIS_DNS/SERVER_INFO", 0, 0, 0, 
+	Server_info_id = (int)dis_add_service( "DIS_DNS/SERVER_INFO", 0, 0, 0, 
 						get_dns_server_info, 0 );
 	dis_add_cmnd( "DIS_DNS/PRINT_STATS", 0, print_stats, 0 );
@@ -1454,5 +1454,5 @@
 	dis_add_cmnd( "DIS_DNS/PRINT_HASH_TABLE", 0, print_hash_table, 0 );
 	dis_add_cmnd( "DIS_DNS/SERVICE_INFO/RpcIn", "C", set_rpc_info, 0 );
-	Rpc_id = dis_add_service( "DIS_DNS/SERVICE_INFO/RpcOut", "C", 0, 0, 
+	Rpc_id = (int)dis_add_service( "DIS_DNS/SERVICE_INFO/RpcOut", "C", 0, 0, 
 						get_rpc_info, 0 );
 	dns_port = get_dns_port_number();
@@ -1586,5 +1586,5 @@
 			{
 				type = DNS_DIS_SOFT_EXIT;
-				type |= (soft_code << 16) & 0xFFFF0000;
+				type |= (soft_code << (int)16) & (int)0xFFFF0000;
 				dim_print_date_time();
 				printf(" Killing server %s@%s with exit code %d\n",
@@ -1649,5 +1649,5 @@
 	if( (servp = (RED_DNS_SERVICE *) dll_search(
 					(DLL *) Service_hash_table[index],
-			      		name, strlen(name)+1)) )
+			      		name, (int)strlen(name)+1)) )
 	{
 		ptr = (char *)servp - (2 * sizeof(void *));
@@ -1719,5 +1719,5 @@
 
 	Service_info_list = (DNS_SERVICE **)
-		malloc(Curr_n_services*sizeof(DNS_SERVICE *));
+		malloc((size_t)(Curr_n_services*(int)sizeof(DNS_SERVICE *)));
 
 	if(!strchr(wild_name, '*'))
@@ -1768,5 +1768,5 @@
 							break;
 						}
-						dptr1 += strlen(tmp);
+						dptr1 += (int)strlen(tmp);
 						ptr = ptr1;
 						dptr = dptr1;
@@ -1784,5 +1784,5 @@
 					if(!strncmp(dptr, tmp, strlen(tmp)))
 					{
-						dptr += strlen(tmp);
+						dptr += (int)strlen(tmp);
 						ptr = ptr1;
 					}
@@ -1839,5 +1839,5 @@
 	if(!Rpc_info_size)
 	{
-		Rpc_info = malloc(MAX_NAME*(n+1)*2);
+		Rpc_info = malloc((size_t)(MAX_NAME*(n+1)*2));
 		Rpc_info_size = MAX_NAME*(n+1)*2;
 	}
@@ -1845,5 +1845,5 @@
 	{
 		free(Rpc_info);
-		Rpc_info = malloc(MAX_NAME*(n+1)*2);
+		Rpc_info = malloc((size_t)(MAX_NAME*(n+1)*2));
 		Rpc_info_size = MAX_NAME*(n+1)*2;
 	}
@@ -1863,5 +1863,5 @@
 				if( (ptr = strstr(Rpc_info, aux)) )
 				{
-					ptr += strlen(aux);
+					ptr += (int)strlen(aux);
 					if(*ptr == '|')
 						rpc = 2;
@@ -1874,5 +1874,5 @@
 				if( (ptr = strstr(Rpc_info, aux)) )
 				{
-					ptr += strlen(aux);
+					ptr += (int)strlen(aux);
 					if(*ptr == '|')
 						rpc = 2;
@@ -1896,5 +1896,5 @@
 						strcat(rpcaux,"|RPC\n");
 						strcpy(rpcptr, rpcaux);
-						rpcptr += strlen(rpcaux);
+						rpcptr += (int)strlen(rpcaux);
 					}
 				}
@@ -1911,5 +1911,5 @@
 				strcat(rpcaux,"|\n");
 			strcpy(rpcptr, rpcaux);
-			rpcptr += strlen(rpcaux);
+			rpcptr += (int)strlen(rpcaux);
 		}
 	}
@@ -1926,5 +1926,5 @@
 	if(tag){}
 	*buffer = Rpc_info;
-	*size = strlen(Rpc_info)+1;
-}
-
+	*size = (int)strlen(Rpc_info)+1;
+}
+
